/*
 * A n t l r  T r a n s l a t i o n  H e a d e r
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-2001
 * Purdue University Electrical Engineering
 * With AHPCRC, University of Minnesota
 * ANTLR Version 1.33MR33
 *
 *   /usr/bin/antlr -k 1 -CC -w2 -fl CueLexer.dlg -ft CueParserTokens.h ./CueParser.g
 *
 */

#define ANTLR_VERSION	13333
#include "pcctscfg.h"
#include "pccts_stdio.h"
#include "CueParserTokens.h"

#include <config.h>
#include <stdlib.h>
#include <string.h>
#include "Toc.h"
#include "TrackData.h"
#include "util.h"
struct CueTrackData;
#include "AParser.h"
#include "CueParserGram.h"
#include "DLexerBase.h"
#include "ATokPtr.h"

/* MR23 In order to remove calls to PURIFY use the antlr -nopurify option */

#ifndef PCCTS_PURIFY
#define PCCTS_PURIFY(r,s) memset((char *) &(r),'\0',(s));
#endif


#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include "CueLexerBase.h"

/* Use 'ANTLRCommonToken' as 'ANTLRToken' to be compatible with some bug
* fix releases of PCCTS-1.33. The drawback is that the token length is
* limited to 100 characters. This might be a problem for long file names.
* Define 'USE_ANTLRCommonToken' to 0 if you want to use the dynamic token
* which handles arbitrary token lengths (there'll be still a limitation in
* the lexer code but that's more than 100 characters). In this case it might
* be necessary to adjust the types of the member functions to the types in
* 'ANTLRAbstractToken' defined in PCCTSDIR/h/AToken.h'.
*/

#define USE_ANTLRCommonToken 0

#if USE_ANTLRCommonToken

typedef ANTLRCommonToken ANTLRToken;

#else

class ANTLRToken : public ANTLRRefCountToken {
private:
ANTLRTokenType type_;
int line_;
ANTLRChar *text_;

public:
ANTLRToken(ANTLRTokenType t, ANTLRChar *s) 
: ANTLRRefCountToken(t, s)
{ 
setType(t); 
line_ = 0; 
setText(s); 
}
ANTLRToken()
{ 
setType((ANTLRTokenType)0); 
line_ = 0; 
setText("");
}
virtual ~ANTLRToken() { delete[] text_; }

#if 0
// use this for basic PCCTS-1.33 release
ANTLRTokenType getType()	 { return type_; }
virtual int getLine()		 { return line_; }
ANTLRChar *getText()		 { return text_; }
void setText(ANTLRChar *s)     { text_ = strdupCC(s); }
#else
// use this for PCCTS-1.33 bug fix releases
ANTLRTokenType getType() const { return type_; }
virtual int getLine()    const { return line_; }
ANTLRChar *getText()	   const { return text_; }
void setText(const ANTLRChar *s)     { text_ = strdupCC(s); }
#endif

  void setType(ANTLRTokenType t) { type_ = t; }
void setLine(int line)	 { line_ = line; }

  virtual ANTLRAbstractToken *makeToken(ANTLRTokenType tt, ANTLRChar *txt,
int line)
{
ANTLRAbstractToken *t = new ANTLRToken(tt,txt);
t->setLine(line);
return t;
}
};
#endif

class CueLexer : public CueLexerBase {
  public:
  CueLexer(DLGInputStream *in, unsigned bufsize=2000)
  : CueLexerBase(in, bufsize) { parser_ = NULL; }
  
  virtual ANTLRTokenType erraction();
  
  CueParserGram *parser_;   
};

struct CueTrackData {
  TrackData::Mode mode;
  long offset;
  long pregap;
  long indexCnt;
  long index[99];
  unsigned int swap : 1;
  unsigned int copy : 1;
  unsigned int fourChannelAudio : 1;
  unsigned int preemphasis : 1;
};

int
CueParserGram::cue(CueTrackData * trackData)
{
  int   _retv;
  zzRULE;
  PCCTS_PURIFY(_retv,sizeof(int  ))
  _retv = 0;
  int lineNr = 0;
  int i;
  TrackData::Mode mode;
  int index;
  Msf m;
  int swapSamples = 0;
  char *s = NULL;
  {
    for (;;) {
      if ( !((setwd1[LA(1)]&0x1))) break;
      if ( (LA(1)==File) ) {
        zzmatch(File); consume();
        {
          if ( (LA(1)==FileName) ) {
            zzmatch(FileName); consume();
          }
          else {
            if ( (setwd1[LA(1)]&0x2) ) {
              {
                while ( (LA(1)==String) ) {
                  zzmatch(String); consume();
                }
              }
            }
            else {FAIL(1,err1,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
        {
          if ( (LA(1)==Binary) ) {
            zzmatch(Binary);
            swapSamples = 1;
 consume();
          }
          else {
            if ( (LA(1)==Motorola) ) {
              zzmatch(Motorola);
              swapSamples = 0;
 consume();
            }
            else {FAIL(1,err2,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
      }
      else {
        if ( (LA(1)==Catalog) ) {
          zzmatch(Catalog); consume();
          zzmatch(CatalogNr); consume();
        }
        else break; /* MR6 code for exiting loop "for sure" */
      }
    }
  }
  {
    ANTLRTokenPtr _t21=NULL;
    int zzcnt=1;
    do {
      zzmatch(TrackDef); _t21 = (ANTLRTokenPtr)LT(1); consume();
      { struct _rv2 _trv; _trv = integer();

      i = _trv.i; lineNr   = _trv.lineNr; }
      if (_retv >= 99) {
        message(-2, "%s:%d: Too many tracks.", filename_, _t21->getLine());
        error_ = 1;
      }
      else {
        trackData[_retv].pregap = 0;
        trackData[_retv].swap = (swapSamples ? 1 : 0);
        trackData[_retv].copy = 0;
        trackData[_retv].fourChannelAudio = 0;
        trackData[_retv].preemphasis = 0;
        index = 0;
      }
        mode   = trackMode();

      if (_retv < 99) {
        trackData[_retv].mode = mode;
      }
      {
        ANTLRTokenPtr _t32=NULL;
        for (;;) {
          if ( !((setwd1[LA(1)]&0x4))) break;
          if ( (LA(1)==Flags) ) {
            zzmatch(Flags); consume();
            {
              int zzcnt=1;
              do {
                if ( (LA(1)==33) ) {
                  zzmatch(33);
                  trackData[_retv].copy = 1;
 consume();
                }
                else {
                  if ( (LA(1)==20) ) {
                    zzmatch(20);
                    trackData[_retv].fourChannelAudio = 1;
 consume();
                  }
                  else {
                    if ( (LA(1)==34) ) {
                      zzmatch(34);
                      trackData[_retv].preemphasis = 1;
 consume();
                    }
                    /* MR10 ()+ */ else {
                      if ( zzcnt > 1 ) break;
                      else {FAIL(1,err3,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
                    }
                  }
                }
                zzcnt++;
              } while ( 1 );
            }
          }
          else {
            if ( (LA(1)==Isrc) ) {
              zzmatch(Isrc); consume();
              zzmatch(IsrcCode); _t32 = (ANTLRTokenPtr)LT(1);
              message(0, "%s", _t32->getText());
 consume();
            }
            else break; /* MR6 code for exiting loop "for sure" */
          }
        }
      }
      {
        if ( (LA(1)==Pregap) ) {
          zzmatch(Pregap); consume();
            m   = msf();

          if (_retv < 99) {
            trackData[_retv].pregap = m.lba();
          }
        }
        else {
          if ( (LA(1)==Index) ) {
          }
          else {FAIL(1,err4,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
      zzmatch(Index); consume();
      { struct _rv2 _trv; _trv = integer();

      i = _trv.i; lineNr   = _trv.lineNr; }
        m   = msf();

      if (_retv < 99) {
        trackData[_retv].offset = m.lba();
        
	   if (i == 1) {
          trackData[_retv].index[index] = m.lba();
          index++;
        }
      }
      {
        ANTLRTokenPtr _t31=NULL;
        while ( (LA(1)==Index) ) {
          zzmatch(Index); _t31 = (ANTLRTokenPtr)LT(1); consume();
          { struct _rv2 _trv; _trv = integer();

          i = _trv.i; lineNr   = _trv.lineNr; }
            m   = msf();

          if (_retv < 99) {
            if (index < 99) {
              trackData[_retv].index[index] = m.lba();
              index++;
            }
            else {
              message(-2, "%s:%d: Too many index marks.",
              filename_, _t31->getLine());
              error_ = 1;
            }
          }
        }
      }
      {
        if ( (LA(1)==Postgap) ) {
          zzmatch(Postgap); consume();
            m   = msf();

        }
        else {
          if ( (setwd1[LA(1)]&0x8) ) {
          }
          else {FAIL(1,err5,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
        }
      }
      if (_retv < 99) {
        if (index == 0) {
          message(-2, "%s:%d: Track %d: Missing Index 1.",
          filename_, _t21->getLine(), _retv + 1);
          error_ = 1;
        }
        trackData[_retv].indexCnt = index;
        _retv += 1;
      }
    } while ( (LA(1)==TrackDef) );
  }
  zzmatch(Eof); consume();
  return _retv;
fail:
  _retv = 0;
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd1, 0x10);
  return _retv;
}

CueParserGram::_rv2
CueParserGram::integer(void)
{
  struct _rv2 _retv;
  zzRULE;
  ANTLRTokenPtr _t11=NULL;
  PCCTS_PURIFY(_retv,sizeof(struct _rv2))
  _retv.i = 0;
  zzmatch(Integer); _t11 = (ANTLRTokenPtr)LT(1);
  _retv.i = atol(_t11->getText()); _retv.lineNr = _t11->getLine();
 consume();
  return _retv;
fail:
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd1, 0x20);
  return _retv;
}

Msf
CueParserGram::msf(void)
{
  Msf   _retv;
  zzRULE;
  PCCTS_PURIFY(_retv,sizeof(Msf  ))
  int min = 0;
  int sec = 0;
  int frac = 0;
  int err = 0;
  int minLine;
  int secLine;
  int fracLine;
  { struct _rv2 _trv; _trv = integer();

  min = _trv.i; minLine  = _trv.lineNr; }
  zzmatch(35); consume();
  { struct _rv2 _trv; _trv = integer();

  sec = _trv.i; secLine  = _trv.lineNr; }
  zzmatch(35); consume();
  { struct _rv2 _trv; _trv = integer();

  frac = _trv.i; fracLine  = _trv.lineNr; }
  if (min < 0) {
    fprintf(stderr, "%s:%d: Illegal minute field: %d\n", filename_,
    minLine, min);
    err = error_ = 1;
  }
  if (sec < 0 || sec > 59) {
    fprintf(stderr, "%s:%d: Illegal second field: %d\n", filename_,
    secLine, sec);
    err = error_ = 1;
  }
  if (frac < 0 || frac > 74) {
    fprintf(stderr, "%s:%d: Illegal fraction field: %d\n", filename_,
    fracLine, frac);
    err = error_ = 1;
  }
  
       if (err != 0) {
    _retv = Msf(0);
  }
  else {
    _retv = Msf(min, sec, frac);
  }
  return _retv;
fail:
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd1, 0x40);
  return _retv;
}

TrackData::Mode
CueParserGram::trackMode(void)
{
  TrackData::Mode   _retv;
  zzRULE;
  PCCTS_PURIFY(_retv,sizeof(TrackData::Mode  ))
  {
    if ( (LA(1)==Audio) ) {
      zzmatch(Audio);
      _retv = TrackData::AUDIO;
 consume();
    }
    else {
      if ( (LA(1)==Mode1_2048) ) {
        zzmatch(Mode1_2048);
        _retv = TrackData::MODE1;
 consume();
      }
      else {
        if ( (LA(1)==Mode1_2352) ) {
          zzmatch(Mode1_2352);
          _retv = TrackData::MODE1_RAW;
 consume();
        }
        else {
          if ( (LA(1)==Mode2_2336) ) {
            zzmatch(Mode2_2336);
            _retv = TrackData::MODE2_FORM_MIX;
 consume();
          }
          else {
            if ( (LA(1)==Mode2_2352) ) {
              zzmatch(Mode2_2352);
              _retv = TrackData::MODE2_RAW;
 consume();
            }
            else {FAIL(1,err6,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
          }
        }
      }
    }
  }
  return _retv;
fail:
  syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
  resynch(setwd1, 0x80);
  return _retv;
}

ANTLRTokenType CueLexer::erraction()
{
  message(-2, "%s:%d: Illegal token: %s", parser_->filename_,
  _line, _lextext);
  parser_->error_ = 1;
  return Eof;
}

void CueParserGram::syn(_ANTLRTokenPtr tok, ANTLRChar *egroup,
SetWordType *eset, ANTLRTokenType etok, int k)
{
  int line;
  
  error_ = 1;
  line = LT(1)->getLine();
  
  fprintf(stderr, "%s:%d: syntax error at \"%s\"", filename_, line,
  LT(1)->getType() == Eof ? "EOF" : LT(1)->getText());
  if ( !etok && !eset ) {
    fprintf(stderr, "\n");
    return;
  }
  if ( k==1 ) {
    fprintf(stderr, " missing");
  }
  else {
    fprintf(stderr, "; \"%s\" not", LT(1)->getText());
    if ( set_deg(eset)>1 ) fprintf(stderr, " in");
  }
  if ( set_deg(eset)>0 )
  edecode(eset);
  else fprintf(stderr, " %s", token_tbl[etok]);
  
  if ( strlen(egroup) > 0 )
  fprintf(stderr, " in %s", egroup);
  
  fprintf(stderr, "\n");
}

static Toc *createToc(const char *cueFileName, const char *binFileName,
CueTrackData *trackData, int nofTracks)
{
  int t, i;
  int fd, ret;
  struct stat sbuf;
  long binFileLength;
  long byteOffset = 0;
  long blockLen;
  TrackData::SubChannelMode subChanMode = TrackData::SUBCHAN_NONE;
  
  if ((fd = open(binFileName, O_RDONLY)) < 0) {
    message(-2, "Cannot open bin file '%s': %s", binFileName, strerror(errno));
    return NULL;
  }
  
  ret = fstat(fd, &sbuf);
  close(fd);
  
  if (ret != 0) {
    message(-2, "Cannot access bin file '%s': %s", binFileName,
    strerror(errno));
    return NULL;
  }
  
  binFileLength = sbuf.st_size;
  
  Toc *toc = new Toc; 
  Msf trackLength;
  
  toc->tocType(Toc::CD_DA);
  
  for (t = 0; t < nofTracks; t++) {
    Track track(trackData[t].mode, subChanMode);
    
    blockLen = TrackData::dataBlockSize(trackData[t].mode, subChanMode);
    
    // very simplified guessing of toc type
    switch (trackData[t].mode) {
      case TrackData::MODE1:
      case TrackData::MODE1_RAW:
      case TrackData::MODE2:
      toc->tocType(Toc::CD_ROM);
      break;
      case TrackData::MODE2_RAW:
      case TrackData::MODE2_FORM_MIX:
      toc->tocType(Toc::CD_ROM_XA);
      break;
      default:
      break;
    }
    
    track.preEmphasis(trackData[t].preemphasis);
    track.copyPermitted(trackData[t].copy);
    track.audioType(trackData[t].fourChannelAudio);
    
    if (t < nofTracks - 1) {
      if (trackData[t + 1].offset <= trackData[t].offset) {
        message(-2, "%s: Invalid start offset for track %d.", 
        cueFileName, t + 2);
        delete toc;
        return NULL;
      }
      
      trackLength = Msf(trackData[t + 1].offset - trackData[t].offset);
    }
    else {
      if (byteOffset >= sbuf.st_size) {
        message(-2, "Length of bin file \"%s\" does not match cue file.",
        binFileName);
        delete toc;
        return NULL;
      }
      
      if (((sbuf.st_size - byteOffset) % blockLen) != 0) {
        message(-1,
        "Length of bin file \"%s\" is not a multiple of block size.",
        binFileName);
      }
      
      trackLength = Msf((sbuf.st_size - byteOffset) / blockLen);
    }
    
    /*
    if (trackLength.lba() < 4 * 75) {
    message(-2, "%s: Track %d is shorter than 4 seconds.", cueFileName,
    t + 1);
    delete toc;
    return NULL;
  }
  */
  
    if (trackData[t].mode == TrackData::AUDIO) {
  if (trackData[t].pregap > 0) {
  track.append(SubTrack(SubTrack::DATA,
  TrackData(Msf(trackData[t].pregap).samples())));
}

      SubTrack st(SubTrack::DATA, TrackData(binFileName, byteOffset, 0,
trackLength.samples()));

      st.swapSamples(trackData[t].swap);

      track.append(st);
}
else {
if (trackData[t].pregap > 0) {
track.append(SubTrack(SubTrack::DATA, 
TrackData(trackData[t].mode, subChanMode,
trackData[t].pregap * blockLen)));
}

      track.append(SubTrack(SubTrack::DATA,
TrackData(trackData[t].mode, subChanMode,
binFileName, byteOffset,
trackLength.lba() * blockLen)));
}

    if (trackData[t].index[0] < trackData[t].offset) {
message(-2, "%s: Invalid offset for Index 1 of track %d.",
cueFileName, t + 1);
delete toc;
return NULL;
}

    track.start(Msf(trackData[t].pregap +
trackData[t].index[0] - trackData[t].offset));

    for (i = 1; i < trackData[t].indexCnt; i++) {
if (trackData[t].index[i] <= trackData[t].index[i - 1]) {
message(-2, "%s: Invalid offset for index %d of track %d.",
cueFileName, i + 1, t + 1);
delete toc;
return NULL;
}

      track.appendIndex(Msf(trackData[t].index[i] - trackData[t].index[0]));
}

    toc->append(&track);

    byteOffset += trackLength.lba() * blockLen;
}

  return toc;
}

Toc *parseCue(FILE *fp, const char *filename)
{
  char *s, *p;
  char *binFileName;
  
  DLGFileInput in(fp);
  CueLexer scan(&in);
  ANTLRTokenBuffer pipe(&scan);
  ANTLRToken aToken;
  scan.setToken(&aToken);
  CueParserGram parser(&pipe);
  
  parser.filename_ = filename;
  scan.parser_ = &parser;
  
  parser.error_ = 0;
  parser.init();
  
  CueTrackData *trackData = new CueTrackData[99];
  
  int nofTracks = parser.cue(trackData);
  
  if (parser.error_ != 0 || nofTracks <= 0) {
    delete[] trackData;
    return NULL;
  }
  
  s = strdupCC(filename);
  if ((p = strrchr(s, '.')) != NULL)
  *p  = 0;
  
  binFileName = strdup3CC(s, ".bin", NULL);
  delete[] s;
  
  Toc *toc = createToc(filename, binFileName, trackData, nofTracks);
  
  delete[] binFileName;
  delete[] trackData;
  
  return toc;
}
